/*
 * AAHelper - An AALib Helper Libary
 * (C) Gary Briggs 2003-4
 *
 * AAHelper is free software; you can redistribute it and/or modify
 * it under the  terms of the GNU Library General Public License as
 * published by the Free Software Foundation; either version 2.1 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT  ANY  WARRANTY;  without   even  the  implied  warranty  of
 * MERCHANTABILITY or  FITNESS FOR A PARTICULAR PURPOSE.   See the GNU
 * Library General Public License for more details.
 */ 

#include <math.h>
#include <stdlib.h>
#include <string.h>
#include <aalib.h>
#include "./aa_helper.h"
#include "./aa_helperint.h"


/* You must follow this with a call to aa_flush to make it appear */
void aa_drawtextsprite(aa_context *c, const unsigned char *sprite,
	int width, int height, int left, int top,
	enum aa_attribute attr, int transparent) {

	int x,y;
	unsigned char curr;
	for(x=left;x<left+width && x<aa_scrwidth(c);x++) {
		for(y=top;y<top+height && y<aa_scrheight(c);y++) {
			curr = sprite[(y-top)*width + (x-left)];
			if(transparent > 0 && curr != (unsigned char)transparent) {
				aa_text(c)[y * aa_scrwidth(c) + x] = curr;
				aa_attrs(c)[y * aa_scrwidth(c) + x] = attr;
			}
		}
	}
}

/* You must follow this with a call to aa_render to make it appear */
void aa_drawgraphicsprite(aa_context *c, const unsigned char *sprite,
	int width, int height, int left, int top, int transparent) {

	int x,y;
	char curr;
	for(x=left;x<left+width && x<aa_imgwidth(c);x++) {
		for(y=top;y<top+height && y<aa_imgheight(c);y++) {
			curr = sprite[(y-top)*width + (x-left)];
			if(curr != transparent) {
				aa_putpixel(c,x,y,curr);
			}
		}
	}
}
