/*
 * AAHelper - An AALib Helper Libary
 * (C) Gary Briggs 2003-4
 *
 * AAHelper is free software; you can redistribute it and/or modify
 * it under the  terms of the GNU Library General Public License as
 * published by the Free Software Foundation; either version 2.1 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT  ANY  WARRANTY;  without   even  the  implied  warranty  of
 * MERCHANTABILITY or  FITNESS FOR A PARTICULAR PURPOSE.   See the GNU
 * Library General Public License for more details.
 */ 

#include <math.h>
#include <stdlib.h>
#include <string.h>
#include <aalib.h>
#include "./aa_helper.h"
#include "./aa_helperint.h"


/* Return an index into **choices or -1 */

int aa_menu(aa_context *context, const char *message,
		const char **choices, int numchoices) {
	int i,j;
	int curr_height;
	char choice;

	for(i=0;i<numchoices;) {
		aa_fastrender(context,0,0,aa_scrwidth(context),aa_scrheight(context));
		curr_height = 3;
		aa_puts(context, 3, curr_height++, AA_SPECIAL, message);

		for(j=0;j<=9 && j<numchoices - i;j++) {
			aa_printf(context, 4, ++curr_height, AA_SPECIAL,
				"%i: %s",j,choices[i+j]);
		}
		if((i+j)<numchoices) {
			aa_puts(context, 4, ++curr_height, AA_SPECIAL, "Space: Next");
		} else {
			aa_puts(context, 4, ++curr_height, AA_SPECIAL, "Space: Cancel");
		}
		aa_flush(context);
		choice = aa_getkey(context, 1);
		if(choice >= '0' && choice <= '0'+j) {
			return(i + choice - '0');
		}
		i+=j;
	}
	return -1;
}
